function  [vysledek] = filtr_UHMF(nefilt,delka,metoda)

h = waitbar(0,'Pracuji...'); %nastaveni waitbaru
tic
for z=1:delka%delka
Im=cell2mat(nefilt(z));
[x,y]=size(Im); 
for i=3:x-2 
    for k=3:y-2
        kriz=max([Im(i-2,k-2) Im(i-1,k-1) Im(i,k) Im(i+1,k+1) Im(i+2,k+2) Im(i+2,k-2) Im(i+1,k-1) Im(i-1,k+1) Im(i-2,k+2)]); %najiti prvku ktere tvori kriz
        plus=sort([Im(i-2,k) Im(i-1,k) Im(i,k) Im(i+1,k) Im(i+2,k) Im(i,k-2) Im(i,k-1) Im(i,k+1) Im(i,k+2)]);%najiti prvku ktere tvori plus
        stred=Im(i,k);%stred
        med=(sort([kriz plus(5) stred])); % serazení trech vybraných prvků
        pom(i,k)=med(2);%vysledek uhmf
        
    end
end
timestr = [metoda, remain_time(z,delka)];
waitbar(z/delka,h,timestr);%nastaveni waitbaru
vysledek(z)={(pom)};
end
close(h)